/*
 (c) Copyright, Real-Time Innovations, $Date: 2006/10/13 08:18:50 $.
 All rights reserved.
 No duplications, whole or partial, manual or electronic, may be made
 without express written permission.  Any such copies, or
 revisions thereof, must display this notice unaltered.
 This code contains trade secrets of Real-Time Innovations, Inc.
*/

#ifndef ThroughputCommon_h
#define ThroughputCommon_h

#ifndef ndds_cpp_h
  #include "ndds/ndds_cpp.h"
#endif

#define WIRE_PROTOCOL_OVERHEAD 1024 
/* Very conservative estimate to account for overhead */

#define TEST_VERBOSITY_ERRORS    1
#define TEST_VERBOSITY_WARNINGS  2
#define TEST_VERBOSITY_MESSAGES  3

#define MAX_TEST_SUBSCRIBERS 16
#define MIN_TEST_DURATION_SEC 1

#define DEFAULT_TEST_DURATION 10 /* 10 seconds */
#define DEFAULT_TEST_STRENGTH 5
#define DEFAULT_NUMBER_OF_SUBSCRIBERS 1

#define DEFAULT_DEMAND 10 /* Message per write loop */
#define DEFAULT_PUBLISHER_PARTICIPANT_INDEX 0
#define DEFAULT_SUBSCRIBER_PARTICIPANT_INDEX 1

#define DEFAULT_MAX_BLOCKING_TIME_NS   999000000
#define DEFAULT_FAST_HEARTBEAT_TIME_NS  1000000

#define THROUGHPUT_PACKET_OVERHEAD 12 /* 4 bytes for key, 4 bytes for length of
    sequence and 4 bytes for sequence number. */
#define DEFAULT_PACKET_SIZE (1024 - THROUGHPUT_PACKET_OVERHEAD)

#define NANOSEC_PER_MILLISEC 1000000

#define MESSAGE_SIZE_MAX 63488 /* 62 * 1024 */
#define MAX_SAMPLES 100

#define MAX_EVENT_COUNT (1024 * 16)

#define MAX_ACCEPTABLE_PACKET_LOSS 4

#ifndef AppLog_report
  #define AppLog_report printf
#endif
#ifndef AppLog_exception
  #define AppLog_exception printf
#endif
#ifndef AppLog_warn
  #define AppLog_warn printf
#endif

extern const DDS_Duration_t ten_millisec;
extern const DDS_Duration_t twenty_millisec;
extern const DDS_Duration_t hundred_millisec;
extern const DDS_Duration_t one_second;
extern const DDS_Duration_t three_second;

void set_logger_verbosity(int ndds_verbosity);

#endif /* ThroughputCommon_h */
